#include <sys/param.h>
#include <sys/kernel.h>
#include <sys/module.h>
#include <sys/sysctl.h>
#include <sys/systm.h>

SYSCTL_NODE(_debug, OID_AUTO, mwait, CTLFLAG_RW, 0, "");
SYSCTL_NODE(_debug, OID_AUTO, monitor, CTLFLAG_RW, 0, "");

static int
sysctl_monitor_doit(SYSCTL_HANDLER_ARGS)
{
	int error, doit;

	doit = 0;
	error = sysctl_handle_int(oidp, &doit, 0, req);
	if (error || req->newptr == NULL || doit == 0)
		return (error);

	cpu_monitor(&doit, 0, 0);
	return (0);
}

SYSCTL_PROC(_debug_monitor, OID_AUTO, doit, CTLTYPE_INT|CTLFLAG_RW, 0, 0, 
    sysctl_monitor_doit, "I", "");

static int
sysctl_mwait_doit(SYSCTL_HANDLER_ARGS)
{
	int error, doit;

	doit = 0;
	error = sysctl_handle_int(oidp, &doit, 0, req);
	if (error || req->newptr == NULL || doit == 0)
		return (error);

	cpu_mwait(0, 0);
	return (0);
}

SYSCTL_PROC(_debug_mwait, OID_AUTO, doit, CTLTYPE_INT|CTLFLAG_RW, 0, 0, 
    sysctl_mwait_doit, "I", "");

static int
mwait_modevent(module_t mod, int type, void *unused)
{

        switch (type) {
        case MOD_LOAD:
		break;
	case MOD_UNLOAD:
		break;
	default:
		return (EINVAL);
	}

	return (0);
}

static moduledata_t mwait_mod_data= {
	"mwait",
	mwait_modevent,
};

DECLARE_MODULE(test, mwait_mod_data, SI_SUB_SMP + 1, SI_ORDER_ANY);
